/*-----------------------------------------------------------------------------

 2002, Jeff McClintock, SynthEdit 

-----------------------------------------------------------------------------*/
#include "Module.h"
#include "Module_Add.h"
#include "Module_Sub.h"
#include "Module_Mul.h"
#include "Module_Div.h"
#include "Module_Abs.h"
#include "Module_Mod.h"
#include "Module_Min.h"
#include "Module_Max.h"
#include "Module_Ipart.h"
#include "Module_Fpart.h"
#include "Module_Pow.h"
#include "Module_Sqrt.h"
#include "Module_Sin.h"
#include "Module_Asin.h"
#include "Module_Sinh.h"
#include "Module_Cos.h"
#include "Module_Acos.h"
#include "Module_Cosh.h"
#include "Module_Tan.h"
#include "Module_Atan.h"
#include "Module_Tanh.h"
#include "Module_Ln.h"
#include "Module_Log.h"


#include "semod_struct.h"

#define MOD_PROPS(num, mod) \
    case num: \
        { \
        mod::getModuleProperties(p_properties); \
        break ; \
        }

extern "C" {
__declspec (dllexport)
int getModuleProperties(int p_index, SEModuleProperties* p_properties)
{
	p_properties->sdk_version = SDK_VERSION;

	switch( p_index )								// !!TODO!! list your in / out plugs
	{
	MOD_PROPS(0, Module);
    MOD_PROPS(1, Module_Add);
    MOD_PROPS(2, Module_Sub);
    MOD_PROPS(3, Module_Mul);
    MOD_PROPS(4, Module_Div);
    MOD_PROPS(5, Module_Abs);
    MOD_PROPS(6, Module_Mod);
    MOD_PROPS(7, Module_Min);
    MOD_PROPS(8, Module_Max);
    MOD_PROPS(9, Module_Ipart);
    MOD_PROPS(10, Module_Fpart);
    MOD_PROPS(11, Module_Pow);
    MOD_PROPS(12, Module_Sqrt);
    MOD_PROPS(13, Module_Sin);
    MOD_PROPS(14, Module_Asin);
    MOD_PROPS(15, Module_Sinh);
    MOD_PROPS(16, Module_Cos);
    MOD_PROPS(17, Module_Acos);
    MOD_PROPS(18, Module_Cosh);
    MOD_PROPS(19, Module_Tan);
    MOD_PROPS(20, Module_Atan);
    MOD_PROPS(21, Module_Tanh);
    MOD_PROPS(22, Module_Ln);
    MOD_PROPS(23, Module_Log);
	default:
		return false; // host will ask for module 0,1,2,3 etc. return false to signal when done
	};

	return true;

}
}

#define ADD_MODULE(num, mod) \
    case num: \
        { \
        if(p_type == 1) \
            { \
            SEModule_base *effect = new mod(seaudioMaster, p_resvd1); \
            if(!effect) \
                return 0; \
            return effect->getAeffect(); \
            } \
        break; \
        }

        

extern "C" {
__declspec (dllexport)
void * makeModule(int p_index, int p_type, seaudioMasterCallback2 seaudioMaster, void *p_resvd1)
{
	switch( p_index )								// !!TODO!! list your in / out plugs
	{
	ADD_MODULE(0, Module);
    ADD_MODULE(1, Module_Add);
    ADD_MODULE(2, Module_Sub);
    ADD_MODULE(3, Module_Mul);
    ADD_MODULE(4, Module_Div);
    ADD_MODULE(5, Module_Abs);
    ADD_MODULE(6, Module_Mod);
    ADD_MODULE(7, Module_Min);
    ADD_MODULE(8, Module_Max);
    ADD_MODULE(9, Module_Ipart);
    ADD_MODULE(10, Module_Fpart);
    ADD_MODULE(11, Module_Pow);
    ADD_MODULE(12, Module_Sqrt);
    ADD_MODULE(13, Module_Sin);
    ADD_MODULE(14, Module_Asin);
    ADD_MODULE(15, Module_Sinh);
    ADD_MODULE(16, Module_Cos);
    ADD_MODULE(17, Module_Acos);
    ADD_MODULE(18, Module_Cosh);
    ADD_MODULE(19, Module_Tan);
    ADD_MODULE(20, Module_Atan);
    ADD_MODULE(21, Module_Tanh);
    ADD_MODULE(22, Module_Ln);
    ADD_MODULE(23, Module_Log);
	};

	return 0;
}
}

#if WIN32
#include <windows.h>
void* hInstance;
BOOL WINAPI DllMain (HINSTANCE hInst, DWORD dwReason, LPVOID lpvReserved)
{
	hInstance = hInst;
	return 1;
}
#endif
